/*
 * mojofiledrop plugin for CKEditor
 * Copyright (C) 2013 Joe Audette, Source Tree Solutions LLC
 * Created 2013-12-12
 * Last Modified 2013-12-12
 *
 */

tinymce.PluginManager.add('mojofiledrop', function(editor, url) {

	if(!(editor.settings.dropFileUploadUrl)) { return; }

	var theEditor = editor;
    var uploadUrl = editor.settings.dropFileUploadUrl;
    
	editor.on('init', function(e) {
		if (window.File && window.FileList && window.FileReader) {
			var document = editor.getDoc();
			document.addEventListener("drop", onDropped, true);
			document.addEventListener("dragover", onDragOver, true);
		}
			
    });
		
	function onDragOver(event) { 
			event.preventDefault();
			return false;	
	 };
				
	function onDropped(event) { 
			event = event || window.event;
			var files = event.dataTransfer.files || event.target.files; 
			if(files) {
				event.preventDefault();
				event.stopPropagation ();
				uploadFile(files[0]); // one file at a time
			}	
	};
			
	function uploadFile(file) {
	
		switch(file.type){
			case "image/jpeg":
			case "image/gif":
			case "image/png":

			var formData = new FormData();
			formData.append(file.name, file);
				
			$.ajax({
				type:"POST",
				processData: false,
				contentType: false,
				dataType: "json",
				url: uploadUrl,
				data: formData,
				success: uploadSuccess,
				complete: ajaxComplete
				});
				
				break;
		}
	}
		
	function ajaxComplete() {
	
	}
		
	function uploadSuccess( data, textStatus, jqXHR ) {
		
		try {
			if(data.files[0].FullSizeUrl) {
				theEditor.insertContent( "<a href='" + data.files[0].FullSizeUrl +"'><img src='" + data.files[0].FileUrl + "' alt=' ' /></a>" );
			}
			else {
				theEditor.insertContent( "<img src='" + data.files[0].FileUrl + "' alt=' ' />" );
			}
		} catch(err) {
			//console.log(err);
			try {
				theEditor.focus();
				if(data.files[0].FullSizeUrl) {
					theEditor.insertContent( "<a href='" + data.files[0].FullSizeUrl +"'><img src='" + data.files[0].FileUrl + "' alt=' ' /></a>" );
				}
				else {
					theEditor.insertContent( "<img src='" + data.files[0].FileUrl + "' alt=' ' />" );
				}
			} catch(err2) {
				//console.log(err2);
			}
		}
		
	}
});
